%----------------------------------------------------------------------------------------
%	PACKAGES EN DOCUMENT CONFIGURATIE
%----------------------------------------------------------------------------------------

\documentclass[a4paper,12pt]{article}
\usepackage{graphicx}
\usepackage[english]{babel}
\usepackage{fancyhdr}
\usepackage{lastpage}
\usepackage{xifthen}
\usepackage{algorithm2e}
\usepackage{lipsum}
\usepackage{hyperref}
\usepackage[utf8]{inputenc}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{float}
\usepackage{subcaption}
%----------------------------------------------------------------------------------------
%	HEADER & FOOTER
%----------------------------------------------------------------------------------------
\pagestyle{fancy}
  \lhead{\includegraphics[width=4.5cm]{logoUU}}		%Zorg dat het logo in dezelfde map staat
  \rhead{\footnotesize \textsc {Lab report\\ \opdracht}}
  \lfoot
    {
	\footnotesize \studentA
	\ifthenelse{\isundefined{\studentB}}{}{\\ \studentB}
	\ifthenelse{\isundefined{\studentC}}{}{\\ \studentC}
	\ifthenelse{\isundefined{\studentD}}{}{\\ \studentD}
	\ifthenelse{\isundefined{\studentE}}{}{\\ \studentE}
    }
  \cfoot{}
  \rfoot{\small \textsc {Page \thepage\ of \pageref{LastPage}}}
  \renewcommand{\footrulewidth}{0.5pt}

\fancypagestyle{firststyle}
 {
  \fancyhf{}
   \renewcommand{\headrulewidth}{0pt}
   \chead{\includegraphics[width=5.5cm]{logoUU}}
   \rfoot{\small \textsc {Page \thepage\ of \pageref{LastPage}}}
 }

\setlength{\topmargin}{-0.3in}
\setlength{\textheight}{630pt}
\setlength{\headsep}{40pt}

%----------------------------------------------------------------------------------------
%	DOCUMENT INFORMATIE
%----------------------------------------------------------------------------------------
%Geef bij ieder command het juiste argument voor deze opdracht. Vul het hier in en het komt op meerdere plekken in het document correct te staan.

\newcommand{\titel}{Report}			%Zelfbedachte titel
\newcommand{\opdracht}{Computer Vision Assignment 4}		%Naam van opdracht die je van docent gehad hebt
\newcommand{\docent}{Ronald Poppe}
\newcommand{\cursus}{Computer Vision}
\newcommand{\vakcode}{INFOMCV}		%Te vinden op oa Datanose
\newcommand{\datum}{\today}					%Pas aan als je niet de datum van vanaag wilt hebben
\newcommand{\studentA}{Jack van der Drift}
\newcommand{\uunetidA}{4098978}
\newcommand{\studentB}{Marjolein Zwerver}			%Uncomment de regel als je met vijf studenten werkt
\newcommand{\uunetidB}{5595363}
%\newcommand{\studentC}{Naam student 3}		%Uncomment de regel als je met drie studenten werkt
\newcommand{\uunetidC}{UUnetID student 3}
%\newcommand{\studentD}{Naam student 4}		%Uncomment de regel als je met vier studenten werkt
\newcommand{\uunetidD}{UUnetID student 4}
%\newcommand{\studentE}{Naam student 5}			%Uncomment de regel als je met vijf studenten werkt
\newcommand{\uunetidE}{UUnetID student 5}

%----------------------------------------------------------------------------------------
%	AUTOMATISCHE TITEL
%----------------------------------------------------------------------------------------
\begin{document}
\thispagestyle{firststyle}
\begin{center}
	\textsc{\Large \opdracht}\\[0.2cm]
		\rule{\linewidth}{0.5pt} \\[0.4cm]
			{ \huge \bfseries \titel}
		\rule{\linewidth}{0.5pt} \\[0.2cm]
	{\large \datum  \\[0.4cm]}
	
	\begin{minipage}{0.4\textwidth}
		\begin{flushleft} 
			\emph{Students:}\\
			{\studentA \\ {\small \uunetidA \\[0.2cm]}}
				\ifthenelse{\isundefined{\studentB}}{}{\studentB \\ {\small \uunetidB \\[0.2cm]}}
				\ifthenelse{\isundefined{\studentC}}{}{\studentC \\ {\small \uunetidC \\[0.2cm]}}
				\ifthenelse{\isundefined{\studentD}}{}{\studentD \\ {\small \uunetidD \\[0.2cm]}}
				\ifthenelse{\isundefined{\studentE}}{}{\studentE \\ {\small \uunetidE \\[0.2cm]}}
		\end{flushleft}
	\end{minipage}
~
	\begin{minipage}{0.4\textwidth}
		\begin{flushright} 
			\emph{Professor:} \\
			\docent \\[0.2cm]
			\emph{Course:} \\
			\cursus \\[0.2cm]
			\emph{Course code:} \\
			\vakcode \\[0.2cm]
		\end{flushright}
	\end{minipage}\\[1 cm]
\end{center}

%----------------------------------------------------------------------------------------
%	INHOUDSOPGAVE EN ABSTRACT 
%----------------------------------------------------------------------------------------

%\tableofcontents
%\begin{abstract}
%\lorem[13]
%\end{abstract}

%----------------------------------------------------------------------------------------
%	INTRODUCTIE
%----------------------------------------------------------------------------------------

\begin{figure}[h]
	\centering
	\includegraphics[scale=0.8]{hurdo}
\end{figure}

\section{Introduction}
For this assignment we decided to detect birds. Since there is a lot of variation within the bird class we decided to take an order of birds which is similarly shaped and makes up a large part of the entire bird species so that we would be able to use as many of the images from the data set as possible. We decided to classify passerines which are birds from the order of Passeriformes, which includes over half of all bird species.

\section{Data}

\subsection{Train and test data}
We used the CUB-200 database that was recommended to us, which contains images of 200 bird species: \url{http://www.vision.caltech.edu/visipedia/CUB-200.html}.  After classifying each species as either passerine or otherwise, we found that about 67\% of our data set is still usable, which should be sufficient. We separated these folders into positive and negative classes and made two separate folders for each pose: one for positive and one for negative class data. 

\subsection{Context}
The circumstances under which we try to detect birds are as follows: we picked the images in which the birds are facing to the right side of the image. A good example can be seen in figure \ref{fig:pose}. From these right facing images we then picked the images in which there is little to no occlusion by branches, grass or other objects to start with. Since we use HOG as our descriptor, we should be able to detect birds under slight angles and with all scales. The illumination in the dataset is quite similar, so we will not be able to detect birds under a lot of variation in illumination.

\begin{figure}[h]
	\centering
	\includegraphics[scale=0.8]{pose}
	\caption{\textit{example image for the right facing pose}}
	\label{fig:pose}
\end{figure}

\subsection{Cutouts}
To actually train our classifier we first needed same sized cutouts for each of the images. We need these equal sized images to generate the hogs for the SVM. The issue here is, that the sizes of the bounding boxes can differ quite in this class. We tried two different methods to solve this issue:

\subsubsection{Add Height}
We want to downscale the boxes, so we find the bounding box with the smallest width. Then we scale all the bounding boxes down to this width and the maximum height between all bounding boxes is taken so we can include all birds. This minimum width and maximum height determine the cutout ratio, which we define as width/height. Each bounding box is now adapted to have this ratio. Since we took the maximum height, the other bounding boxes will lack height so we calculate the new height by dividing the bounding box width by the cutout ratio and then adapting the y coordinate so that an equal part is taken from the top and bottom.

Since there is not a lot of room around the bird in some of the images in the dataset, we discard the images that we do not have enough room to adjust the bounding box for.

Since we noticed that a lot of images were discarded because of this, we introduced a parameter HEIGHT\_ PAR (set to 0.8) to scale down the maximum height in order to get more images for classification. After getting these cutouts with the right ratio, they are resized (shrunk) so that the width and height are the largest multiple of the cell size that still fits within the minimum width and maximum height found earlier.

\subsubsection{Average Ratio}
Since the above solution only increases height, we thought some other solution might work better. For our second approach, we calculate the average ratio of all of the bounding boxes to use as our cutout ratio. We then adapt the bounding boxes to match this ratio. To find the size for all cutouts, we find the smallest width among all adapted bounding boxes and calculate the height using the ratio. All bounding boxes are then resized to the largest multiple of cell size that fits within the width and height. Examples can be found in figure \ref{fig:resize}.

\begin{figure}[h]
	\centering
	\includegraphics[scale=0.28]{resize}
	\caption{\textit{Different methods for gathering positive class cutouts. The first image is the original, the second is the cutout using the bounding box. For the third and fourth column, the top images are the adapted and resized cutout for the method where we only add height and the bottom images are for the average ratio method.}}
	\label{fig:resize}
\end{figure}

\subsection{Negative Class Images}
For the positive class images, we make a negative class cutout for each image using the function getNegCutouts(). This function finds the location (left/right/up/down from the positive class bounding box) where the biggest cutout can be taken. The largest possible cutout with the cutout ratio is then taken from the center of this side. An example of this cutout is shown in figure \ref{fig:negcut}. This cutout is later rescaled to work with the hog descriptor. Note that the blue bounding box does not have the same ratio as the green bounding box since it uses the ratio we found before.

\begin{figure}[h]
	\centering
	\includegraphics[scale=0.6]{negcut}
	\caption{\textit{Negative cutout (blue rectangle) from a positive class image}}
	\label{fig:negcut}
\end{figure}

\section{Processing}

\subsection{Image Descriptor}
For the creation of our feature vectors we use a hog descriptor. We have chosen this descriptor because most birds have a very similar shape. Which means the gradients for images of two birds are very similar. We are not using SIFT or color histograms because these depend too much on the color and texture of a bird, while we are trying to detect a whole range of bird species.

\subsection{Image Classifier}
We are using a SVM as our classifier, since the other classifiers do not fit our specific object. We did not choose K-nearest neighbor because it is very storage and time consuming for large sets. And the reason why we did not choose Naive Bayes is because it does not fit our scenario.
For finding the optimal settings for our SVM we used cross validation combined with the F-score to determine the best variables. 

Because there are a lot variables which can be adjusted in an SVM we started of by determining which type of SVM and which type of kernel we should use. We did this because the type of kernel and the type of SVM determines how many variables are left to optimize, since not every type uses the same variables.

Using cross validation we found that using an EPS\_ SVR SVM with a Linear kernel gave us the best results. In the code you can see that we did not test every SVM type, we did this because some already gave F scores of zero for the standard values (1 or 0.1f depending on the type of the variable). We did not check the ONE\_ Class at all since we are trying to find a SVM using positive and negative images, the ONE\_ Class type only expects positive values and tries to find an encapsulating support vector. We found that this restricted us too much.

Because the linear kernel only depends on the C value and the EPS\_ SCR SVM type only uses the variable p, we can now use cross validation on these two variables to find the optimal ones. These are C: 0.01f and p:0.1f.


\begin{table}[h]
\centering
\begin{tabular}{|l|l|l|l|}
\hline
\textbf{C value} & \textbf{Precision} & \textbf{Recall} & \textbf{F-Score} \\ \hline
0.001 & 0.000 & 0.000 & 0.000 \\ \hline
0.009 & 0.315 & 0.367 & 0.334 \\ \hline
0.01 & 0.329 & 0.411 & 0.360 \\ \hline
0.011 & 0.301 & 0.420 & 0.346 \\ \hline
0.1 & 0.154 & 0.465 & 0.230 \\ \hline
\end{tabular}
\caption{\textit{Cross Validation data for parameter C of the SVM}}
\label{fig:CCross}
\end{table}

From table \ref{fig:CCross}: At first the precision is higher, because we only predict a the location if we are sure there is one. Later it goes down because we predict more locations where there are no birds, thanks to overfitting on the train data. Hence the SVM tries to get all the positives on one side of the line, but since there are outliers which mess up the line, the precision goes down. The same goes for recall since the SVM now takes into account the outliers, it is more likely that we get a higher recall since we predict more of the outlier to be birds.

\subsection{Ratio of positive/negative class images}
We also tested for the ratio of positive and negative class images. We figured that a 50/50 ratio as is described in the assignment would be best, but we found that a ratio closer to 100/50 worked better for us as can be seen in table \ref{fig:posneg}.

\begin{table}[h]
\centering
\begin{tabular}{|l|l|l|l|}
\hline
\textbf{pos/neg ratio} & \textbf{Precision} & \textbf{Recall} & \textbf{F-Score} \\ \hline
0.4                    & 0.329              & 0.411           & 0.360            \\ \hline
0.7                    & 0.251              & 0.509           & 0.318            \\ \hline
1.0                    & 0.128              & 0.432           & 0.192            \\ \hline
\end{tabular}
\caption{\textit{p,r and f-scores for different pos/neg ratios}}
\label{fig:posneg}
\end{table}

\subsection{Amount of Data}
One of the other tests we did was to see how the amount of data we used influenced our f-scores. The results can be found in table \ref{fig:dataSize}.

\begin{table}[h]
\centering
\begin{tabular}{|l|l|l|l|}
\hline
\textbf{\% data} & \textbf{Precision} & \textbf{Recall} & \textbf{F-Score} \\ \hline
60               & 0.431              & 0.145           & 0.193            \\ \hline
70               & 0.350              & 0.175           & 0.230            \\ \hline
80               & 0.475              & 0.173           & 0.228            \\ \hline
90               & 0.305              & 0.358           & 0.325            \\ \hline
100              & 0.329              & 0.411           & 0.360            \\ \hline
\end{tabular}
\caption{\textit{f-scores for cross validation with different sizes of training data}}
\label{fig:dataSize}
\end{table}
As to be expected, the f-scores increase as we use a bigger portion of our data.

\subsection{Detection Threshold}
To determine whether or not a certain detection matches the original bounding box, we use the intersection over union (IoU) for both rectangles. The threshold we initially used was 0.7. Since an IoU of 1.0 can only occur when the bounding box for the bird is the exact same ratio as the ratio we use for the cutouts, which rarely occurs, we decided to adapt this threshold accordingly. We calculate the average IoU between the original bounding box for the bird and the adapted bounding box based on the determined cutout ratio over all training images. We then multiply our original threshold of 0.7 with this number (around 0.8 - 0.9, depending on the parameter settings) to get an adapted threshold for each training set.

\subsection{PR-Curve}
For our precision recall graph we used the optimal parameter settings obtained through 5-fold cross-validation.

\begin{figure}[h]
	\centering
	\includegraphics[scale=0.6]{prCurve}
	\caption{\textit{ Precision Recall Graph}}
	\label{fig:prCurve}
\end{figure}

We created the Precision Recall Graph in figure \ref{fig:prCurve} by looping over the detection threshold value. This was done between the values 0.1 and 1.0 with steps of 0.1. There are 2 values missing namely the ones corresponding to 0.9 and 1.0 since these created scores of zero.

\subsection{Cell Size}
Using cross validation we found that the best cell size for the hog descriptor is 8x8. We think that for this value there is just enough detail left while not being too detailed, which causes the hog to be too precise.

\begin{figure}[h]
	\centering
	\includegraphics[scale=0.7]{cellSize}
	\caption{\textit{ Different cell sizes drawn onto an image. From top left to bottom right: 64x64, 32x32, 16x16, 8x8 and 4x4}}
	\label{fig:cellSize}
\end{figure}

\subsection{Optimal Values \& Code}

The rest of the optimal values that we did not discuss here can be found in the variables.cpp. The reason they are not discussed is because of the little impact they have on the F-score.

We split the code on the functions which belong to the train or test stage. The main is located in Assignment4.cpp here we call which k-folds we are going to use. The functions used for testing the SVM are in testModel.cpp and the train functions are in trainModel.cpp. The functions which are needed by both are in globalfunctions.cpp. It should be quite clear what every function does.
There are also some extra options in variables.h:
\begin{itemize}
\item MIRROR when set to true, also tests the mirrored version of an image. This was initially implemented so we could test both left and right facing birds with the same classifier.
\item ADJ\_ CUT is used to switch between the two methods to obtain cutouts. When set to true, the average ratio method is used and when set to false, the add height method is used.
\item STANDARD\_ CUT is used for switching between getting the optimal size for a cutout or just using a specified standard size.
\item ADP\_ THRESH is used to turn the adapted threshold on or off.
\end{itemize}

We also tried blurring the image before obtaining the gradients. This can be changed by altering the WINSIG parameter in variables.cpp. We got the best scores by using the default value of -1, which doesn’t blur the image.

\section{Reflection}
After using 5-fold cross validation to obtain the best parameter settings for our classifier, we still obtained quite a low f-score of 0.36. We have some ideas on where the issue might lie: the thing that stood out the most for us was the great impact that the positive/negative image ratio seemed to have on our results. We started out with a 50/50 ratio, but more negative images seemed to improve our results. This might have something to do with the bias in the images that we are testing on: with the sliding window over all images, we get a lot of bounding boxes that should be classified as negative. We might account for this by balancing the number of training samples better or incorporating the prior probability for each class, but unfortunately we did not have the time to implement this. 

We also tried to reduce the variation in the exact shape of the birds, by removing some pictures that were too different. We used the optimal settings with the original 114 images and a second set of 82 images. The original set resulted in an f-score of 0.36 and the second set resulted in an f-score of 0.23, showing that this was not the problem either.
In conclusion: we optimized for many parameters involving the SVM, the cutouts and data ratios but we most likely missed something, resulting in low f-scores.

%----------------------------------------------------------------------------------------
%	REFERENTIES
%----------------------------------------------------------------------------------------
%Meer informatie hierover volgt in blok 5 van jaar 1.

\nocite{*}
\bibliographystyle{acm}
%\bibliographystyle{apalike}
%\bibliography{refs}

%----------------------------------------------------------------------------------------
%	BIJLAGEN
%----------------------------------------------------------------------------------------

%\section{Bijlage A}
%\section{Bijlage B}
%\section{Bijlage C}

\end{document}